require "dotenv"
Dotenv.load!

require "pry"
$debug = ENV["DEBUG"] == "true"

require "sequel"
$db = Sequel.connect(ENV["DB_URL"])

require_relative "logger"

module Protocols
  FULL     = "RFC822".freeze
  HEADERS  = "RFC822.HEADER".freeze
  BODYTEXT = "BODY[TEXT]".freeze
  ENVELOPE = "ENVELOPE".freeze
  UID      = "UID".freeze
  SEQ      = "BODY[HEADER.FIELDS (X-SEQUENCE)]".freeze
  MSG_ID   = "BODY[HEADER.FIELDS (MESSAGE-ID)]".freeze
end

require_relative "protocols"
require_relative "models" rescue nil
