class Distributor
  module Actions

    class SetPermissions < Action
      SET_PERMISSIONS_TEMPLATE = Actions.template("set_permissions.success")

      def handle(list:, to:, attributes:)
        return if attributes["user-email"].nil? # drop missing param
        return if attributes["permissions"].nil? # drop missing param

        modo = Email.first(mailinglist: list, email: to.from)
        if !modo&.modo? && !modo&.op?
          $logger.warn "SECU <#{to.from}> failed to set-permissions <#{list.email}> modo"
          return nil
        end

        user_email = attributes["user-email"]
        user = Email.first(mailinglist: list, email: user_email)
        if user.nil?
          $logger.warn "SECU <#{to.from}> failed to set-permissions on non-existing email <#{user_email}>"
          return nil
        end

        if user.op? && !modo.op?
          $logger.warn "SECU <#{to.from}> failed to set-permissions on op email <#{user_email}>"
          return nil
        end

        permissions = attributes["permissions"].to_i
        if Email::Permissions.op?(permissions) && !modo.op?
          $logger.warn "SECU <#{to.from}> failed to set op permissions on email <#{user_email}>"
          return nil
        end

        user.permissions = permissions
        user.save
        body = SET_PERMISSIONS_TEMPLATE.result binding
        @distributor.distribute(Protocols::Mail.build(subject: "ML #{list.name} subscription update", list: list, to: user.email, body: body))
      end
    end

    class ListUsers < Action
    end

  end
end
