class Semver
  def initialize(string)
    @values = string.gsub(/^v(\d.+)/, '\1').split(".").map(&:to_i)
  end

  def [](index)
    @values[index] || 0
  end

  def to_s
    "v#{@values.join(".")}"
  end

  def <=>(left)
    cmp = 0
    @values.each_with_index do |value, index|
      cmp = value - left[index]
      break if cmp != 0
    end
    cmp
  end

  def >(left)
    (self <=> left) > 0
  end

  def <(left)
    (self <=> left) < 0
  end

  def ==(left)
    (self <=> left) == 0
  end

  def !=(left)
    (self <=> left) != 0
  end
end

# pp Utils::Semver.new("1.0") < Utils::Semver.new("1.1")
# pp Utils::Semver.new("0.1") < Utils::Semver.new("1.1")
# pp Utils::Semver.new("1.1") < Utils::Semver.new("1.2")
# pp Utils::Semver.new("1.1") < Utils::Semver.new("2.0")
# pp Utils::Semver.new("12.0") > Utils::Semver.new("2.2")
